use std::collections::HashMap;

pub mod basic_set;
pub mod basic_markov;

pub trait Predictor {

    fn predict(&self, query: &str, n: usize) -> String;
    fn update(&mut self, query: &str) -> Result<(),Box<dyn std::error::Error>>;

    fn new() -> Self where Self: Sized;
    fn new_from_config(config: HashMap<String, impl Into<String>>) -> Self where Self:Sized;
}